/**
 * Copyright (c) 2006-2009 Institut National de Recherche en Informatique et 
 *                         en Automatique. All rights reserved.
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

#include <stdlib.h>

#include "stubs/serviceH.h"
#include "stubs/service.nsmap"

struct Namespace *namespaces;

int main(int argc, char **argv){

  struct ns__noResponse *out;
  struct soap v_soap;
  char server[261];
  sockaddr_t uri_A;
  int len = 256;
  int port;
  char host[len+1];
  
  struct hostent *host_addr;
  process_name_t my_name;

  my_name.cellid = 1;
  my_name.vpid = 2;
  my_name.jobid = 3;

  if(argc<2){
    printf("not enough args. usage:\n\t%s <server>\n", argv[0]);
    return EXIT_FAILURE;
  }

  sprintf( server , "%s", argv[1]);
  port = atoi( argv[2] );
  
  sprintf(server, "%s:%d", server, port);   
  
  gethostname(host, len); 
  host_addr = gethostbyname(host);   
  uri_A.host_name = (char*)malloc(strlen(host_addr->h_addr)+1);
  strcpy(uri_A.host_name, host_addr->h_addr);
  uri_A.port = 11111;
  
  soap_init(&v_soap); 
  soap_set_namespaces(&v_soap, service_namespaces);
  soap_call_ns__putMyURI(&v_soap, server, "", &my_name, &uri_A, OMPI, out);
  if(v_soap.error){soap_print_fault(&v_soap, stderr);}  
  soap_end(&v_soap);

  return EXIT_SUCCESS;

}





