/**
 * Copyright (c) 2006-2009 Institut National de Recherche en Informatique et 
 *                         en Automatique. All rights reserved.
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

#ifndef _debug_h
#define _debug_h

#include <stdio.h>

#ifndef NDEBUG

#define file_name "/tmp/frontale.log"

static pthread_mutex_t debug_lock = PTHREAD_MUTEX_INITIALIZER;

#include <stdarg.h>
static void __debug(const int line, const char *file, 
		    const char *function, const char *format, ...)
{
  va_list ap;
  FILE *fd = NULL;
  pthread_mutex_lock(&debug_lock);
  fd = fopen(file_name, "a+");
  fprintf((fd ? fd : stderr), "%s:%d (%s)", file, line, function);
  va_start(ap, format);
  vfprintf((fd ? fd : stderr), format, ap);
  va_end(ap);
  fprintf((fd ? fd : stderr), "\n");
  fclose(fd);   
  pthread_mutex_unlock(&debug_lock);
}

#define debug(toto...) __debug(__LINE__, __FILE__, __FUNCTION__, toto)

#else
#define debug(toto...) do {} while(0)
#endif

#endif
