/**
 * Copyright (c) 2006-2009 Institut National de Recherche en Informatique et 
 *                         en Automatique. All rights reserved.
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

#ifndef PROXY_H_
#define PROXY_H_

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include "stubs/serviceH.h"

#define PROXY_PORT 4055
#define ERROR -1
#define SUCCESS 0
#define MAX_HOST_NAME 256
#define MAX_IP 16
#define MAXPENDING 1024

#define MAX_BUFFER 1024
#define MAX_PROXY_CONNECTIONS 500
#define UID 1000
#define MAX_CONNECTED 1024
#define MAXFD 64
#define TRANSFER_BUFFER_SIZE 10000

struct proxy_process_name{
  cellid_t cellid;
  jobid_t jobid;
  vpid_t vpid;
  TAG_t tag;
};

struct proxy_connection{
    int client;
    int server;
    int uid;
    pthread_mutex_t mutex;
    pthread_cond_t cond;
    struct proxy_connection *next;
};

struct socket_id {
  struct proxy_process_name ids[MAX_CONNECTED];
  int ids_count;
};

typedef enum{
  codeProxyInit = 600,  // parametres: les id des processus connect  cette machine
  codeConnectionDemand = 601, //parametres: id_proc port
  codeConnectionDemandReponse = 602, 
  codeDeleteId = 603,
  codeUniqueId = 650,
  codeQuit = 700, 
}COMMAND_CODE;

#endif /*PROXY_H_*/
